import sys 
import numpy as np

n = len( sys.argv )
if n != 10 :
	print( "Args: cx cy cz  ox oy oz  ax ay ax" )
	sys.exit(1)

vc = np.zeros( (3,1) )
vo = np.zeros( (3,1) )
va = np.zeros( (3,1) )

vc[0,0] = float( sys.argv[1] )
vc[1,0] = float( sys.argv[2] )
vc[2,0] = float( sys.argv[3] )
 
vo[0,0] = float( sys.argv[4] )
vo[1,0] = float( sys.argv[5] )
vo[2,0] = float( sys.argv[6] )

va[0,0] = float( sys.argv[7] )
va[1,0] = float( sys.argv[8] )
va[2,0] = float( sys.argv[9] )

def calculaR( vc, vo, va ) :
	R = np.zeros( (3,3) )

	vb = vc - vo
	vz = vb/np.sqrt( vb.T @ vb )

	vb = np.cross( va, vz, axisa=0, axisb=0, axisc=0 )
	vx = vb/np.sqrt( vb.T @ vb )

	vy = np.cross( vz, vx, axisa=0, axisb=0, axisc=0 )

	R[0,:] = vx.T
	R[1,:] = vy.T
	R[2,:] = vz.T

	return R
	

def proyecta( p, P, R, vc ) :
	f = 600
	u0 = 319.5
	v0 = 239.5
	K = np.array( [[-f, 0, u0 ], [0, -f, v0], [0, 0, 1]] )

	# El modelo de la cámara oscura
	# l p = K R [I| -c] P
	m, n = P.shape
	i = 0
	P1 = np.zeros( (3,1) )
	while i<m :
		P1[0,0] = P[i,0]
		P1[1,0] = P[i,1]
		P1[2,0] = 0.0

		P1[0,0] -= vc[0,0]
		P1[1,0] -= vc[1,0]
		P1[2,0] -= vc[2,0]

		p2 = K @ R @ P1

		# Homogeneizamos
		p[0,i] = p2[0,0]/p2[2,0]
		p[1,i] = p2[1,0]/p2[2,0]
		p[2,i] = 1

		i += 1

def imprime_proyeccion( p ) :
	n, m = p.shape
	i = 0
	while i < m :
		print( p[0,i], p[1,i] )
		i += 1


# El modelo del marcador
P = np.fromfile( "m4cen", sep=' ' )
P = P.reshape( (-1,2) )

# El modelo proyectado, está en 2D
p = np.zeros( (3,6) )

R = calculaR( vc, vo, va )
# print( R )
proyecta( p, P, R, vc )
imprime_proyeccion( p )
